************************************************************************
* Hlavn program

LOCAL loPar,loForm
* Pidej objekt do objektu _Screen, vyhneme se tm deklaraci PUBLIC promnn
_Screen.AddObject("SP","_StackParameters")

loPar=CREATEOBJECT("_Param") && Vytvo parametr pro pedn hodnot
loPar.Second=loPar.Second+" A"
_Screen.SP.Put(@loPar) && Ulo parametr do zsobnku

loForm=CREATEOBJECT("_dlgForm") && Vytvo instanci formule pro zadn hodnot
* Zde vak me bt
* DO FORM dglForm LINKED NAME loForm
*
* Take je pln jedno, zda je formul definovn jako tda v PRG souboru
* nebo VCX knihovn, i jako ist formul.

* V tto chvli jsou ji hodnoty ve formuli nateny do objekt
*=MESSAGEBOX(loForm.txtSecond.Value)

loForm.Show() && Zobraz formul
* Jeliko je formul modln, zpracovn udlost se zastav,
* dokud formul nen uvolnn z pamti, nebo nen skryt.

IF loPar.OK && Dialog byl potvrzen
   =MESSAGEBOX("Prvn hodnota:"+CHR(9)+loPar.First+;
               CHR(13)+CHR(10)+;
               "Druh hodnota:"+CHR(9)+loPar.Second)
ELSE
   * Dialog nebyl potvrzen
ENDIF

_Screen.RemoveObject("SP") && Odstra Zsobnk parametr
RELE loForm,loPar

************************************************************************
*
#DEFINE _MaxCount 65000 && Maximln poet buek v intern matici

DEFINE CLASS _StackParameters AS custom && Definice tdy zsobnku parametr
   PROTECTED ARRAY aPar(_MaxCount)
   PROTECTED iCount

   iCount=0 && Poet dk matice aPar

   PROCEDURE Put(luPar) && Ulo parametr do zsobnku
      This.iCount=This.iCount+1 && Inkrementuj ta
      DIME This.aPar(This.iCount) && Pedimenzuj matici
      This.aPar(This.iCount)=luPar && Ulo parametr do zsobnku
   ENDPROC

   PROCEDURE Get() && Vybere posledn parametr ze zsobnku
      LOCAl luPar
      IF This.iCount>0 && Pokud v zsobnku nco je
         luPar=This.aPar(This.iCount) && Vyber parametr ze zsobnku
         This.iCount=This.iCount-1 && Dekrementuj ta
         IF This.iCount>0
            DIME This.aPar(This.iCount) && Pedimenzuj matici
         ENDIF
      ELSE
         luPar=.NULL.
      ENDIF
      RETURN luPar && Vra hodnotu
   ENDPROC

ENDDEFINE



************************************************************************
*
DEFINE CLASS _Param AS custom && Definice tdy pro pedn parametr
   OK=.F.            && Pznak o potvrzen dialogu

   First = "First"   && Prvn hodnota
   Second = "Second" && Druh hodnota
ENDDEFINE


**************************************************
*-- Form:         form1 (x:ptrikyquas40_2.scx)
*-- ParentClass:  form
*-- BaseClass:    form
*-- Time Stamp:   04/18/02 03:11:01 PM
*
DEFINE CLASS _dlgForm AS form


Top = 0
Left = 0
Height = 145
Width = 272
DoCreate = .T.
BorderStyle = 2
Caption = "Form1"
WindowType = 1
*-- Na tuto vlastnost se nalinkuje vybran parametr ze zsobnku
param = .NULL.
Name = "dlgForm"


ADD OBJECT txtfirst AS textbox WITH ;
Height = 23, ;
Left = 105, ;
Top = 24, ;
Width = 100, ;
Name = "txtFirst"


ADD OBJECT txtsecond AS textbox WITH ;
Height = 23, ;
Left = 105, ;
Top = 51, ;
Width = 100, ;
Name = "txtSecond"


ADD OBJECT cmdok AS commandbutton WITH ;
Top = 96, ;
Left = 21, ;
Height = 27, ;
Width = 84, ;
Caption = "OK", ;
Default = .T., ;
Name = "cmdOK"


ADD OBJECT cmdcancel AS commandbutton WITH ;
Top = 96, ;
Left = 146, ;
Height = 27, ;
Width = 84, ;
Cancel = .T., ;
Caption = "Zruit", ;
Name = "cmdCancel"


ADD OBJECT lblfirst AS label WITH ;
Caption = "Prvn hodnota:", ;
Height = 17, ;
Left = 15, ;
Top = 29, ;
Width = 80, ;
Name = "lblFirst"


ADD OBJECT lblsecond AS label WITH ;
Caption = "Druh hodnota:", ;
Height = 17, ;
Left = 14, ;
Top = 55, ;
Width = 87, ;
Name = "lblSecond"


PROCEDURE Load

This.Param=_Screen.SP.Get() && Vyber parametr ze zsobnku
* V zde se mou ji nastavit nkter vci pro formul,
* ale hodnoty do objekt se mus nastavit a v udlosti Init()
* (protoe objekty txtFirst a txtSecond neexistuj).
* Vjimku tvo ppady, kdy je formul vytvoen na zklad tdy s vnoenma objektama
ENDPROC


PROCEDURE Init
* Nyn pethni hodnoty z parametru do objekt na formuli
IF !ISNULL(This.Param) && Pokud byl parametr pedn
   Thisform.txtFirst.Value=Thisform.Param.First
   Thisform.txtSecond.Value=Thisform.Param.Second
ENDIF
ENDPROC


PROCEDURE cmdok.Click
IF !ISNULL(Thisform.Param) && Pokud byl parametr pedn
   Thisform.Param.OK=.T. && Nastav potvrzen dialogu
   Thisform.Param.First=Thisform.txtFirst.Value && A ulo hodnoty do vlastnost
   Thisform.Param.Second=Thisform.txtSecond.Value
ENDIF
Thisform.Release() && Ukoni formul
ENDPROC

PROCEDURE cmdcancel.Click
Thisform.Release() && Ukoni formul
ENDPROC


ENDDEFINE
*
*-- EndDefine: form1
**************************************************